#include <iostream>
using namespace std;

// Cream un nou tip de date
template <class T>
class queue {
public:
    queue() : p {0}, u {-1}
    {
    }
    /// functiile OBLIGATORII ale stivei
    void push(T x)
    {
        q[++u] = x;
    }

    void pop()
    {
        p++;
    }

    /// Functii de informare
    T front() const
    {
        return q[p];
    }

    T back() const
    {
        return q[u];
    }

    bool empty() const
    {
        return p > u;
    }

    int size() const
    {
        return u - p + 1;
    }

private:
    int p, u;     /// poz primului, respectiv a ultimului
    T q[1000];    /// elem din coada
};

int main()
{
    queue<int> q1;
    q1.push(10);
    q1.push(20);
    q1.push(30);
    q1.push(40);

    while (!q1.empty())
    {
        cout << q1.front() << ' ';
        q1.pop();
    }

    queue<string> q2;
    q2.push("Ion");
    q2.push("Ana");
    q2.push("Nicusor");
    q2.push("Marcelus");

    while (!q2.empty())
    {
        cout << q2.front() << ' ';
        q2.pop();
    }

}
