#include <iostream>
using namespace std;

// Cream un nou tip de date
template <class T>
class stack {
public:
    stack() : vf {-1}
    {
    }
    /// functiile OBLIGATORII ale stivei
    void push(T x)
    {
        s[++vf] = x;
    }

    void pop()
    {
        vf--;
    }

    /// Functii de informare
    T top() const
    {
        return s[vf];
    }

    bool empty() const
    {
        return vf < 0;
    }

    int size() const
    {
        return vf + 1;
    }

private:
    int vf;     /// poz elem din varful stivei
    T s[1000];
};

int main()
{
    stack<int> s1;
    s1.push(10);
    s1.push(20);
    s1.push(30);
    s1.push(40);

    while (!s1.empty())
    {
        cout << s1.top() << '\n';
        s1.pop();
    }

    stack<string> s2;
    s2.push("Ion");
    s2.push("Ana");
    s2.push("Nicusor");
    s2.push("Marcelus");

    while (!s2.empty())
    {
        cout << s2.top() << '\n';
        s2.pop();
    }

}
